# Contributing to Vue-Functional-Calendar
We love your feedback! We need to make adding to this task as simple and straightforward as could be expected, regardless of whether it's:

- Detailing a bug
- Examining the present status of the code
- Presenting a fix
- Proposing new highlights
- Turning into a maintainer

## We Develop with Github
We use github to have code, to follow issues and component demands, as well as acknowledge pull requests.

## We Use [Github Flow](https://docs.github.com/en/get-started/quickstart/github-flow), So All Code Changes Happen Through Pull Requests
Pull requests are the most ideal way to propose changes to the codebase (we use [Github Flow](https://docs.github.com/en/get-started/quickstart/github-flow)). We effectively welcome your draw demands:

1. Fork the repo and make your branch from 'master'.
2. Assuming you've added code that ought to be tried, add tests.
3. On the off chance that you've changed APIs, update the documentation.
4. Guarantee the test suite passes.
5. Ensure your code lints.
6. Issue that pull request!

## Any commitments you cause will to be under the MIT Software License
To put it plainly, when you submit code changes, your entries are perceived to be under a similar [MIT License](http://choosealicense.com/licenses/mit/) that covers the task. Go ahead and contact the maintainers assuming that is a worry.

## Report bugs utilizing Github's [issues](https://github.com/ManukMinasyan/vue-functional-calendar/issues)
We use GitHub issues to follow public bugs. Report a bug by [opening a new issue](https://github.com/ManukMinasyan/vue-functional-calendar/issues/new); it's just simple!

## Compose bug reports with detail, foundation, and test code

**Extraordinary Bug Reports** will generally have:

- A fast outline or potentially foundation
- Steps to repeat
  - Be explicit!
  - Give test code if possible.
- What you expected would occur
- What really occurs
- Notes (perhaps including why you figure this may be occurring, or stuff you attempted that didn't work)

Individuals *love* exhaustive bug reports. I'm not in any event, joking.

## Use a Consistent Coding Style

* 2 spaces for space rather than tabs
* You can have a go at running 'npm run build up' for style unification

## License
By contributing, you concur that your commitments will be authorized under its MIT License.
